//
// Created by Philippe Reynier on 14.06.2023.
// Functional test 10 for Commode 
// Develop on the base of D5 (ISA TN-02v4-2022): Software Verification Plan for Coma Model for 
// Comet Interceptor
//
// Functional test 10 for Model  (from D2:User and Software requirements definition document)
//
// For this test it is proposd to run the  fountain and numrical modelsfor 1 size bin and compare the dust density at 3 selected locations. Afrho is also compared.
// 


#include "utils.h"
#include "run_models.h"
#include <math.h>
#include <vector>
#include <iostream>

int model(){

    // test (acceptance) checks if the correct value is obtained for scattering properties
    // acceptance is equal to 0 if this is the case
    int acceptance = 1;
    int acceptance1 = 1;
    int acceptance2 = 1;
    int acceptance4 = 1;
    int number_of_bins = 1;
    double afrho1, afrho2;
    // 
    double particle_size = 0.001;
    double particle_density = 533.0;
    int gridsize_apex = 10;
    int gridsize_x = 51;
    int gridsize_y = 10;
    int size_index = 4;
    int cellsize = 25000;
    double beta = 0.0001;
    double v0 = 25.0;
    double Q_sca = 1.0;
    double  amplitude_rot = 0.;
    int angular_dependency_index = 0;
    double  cosine_scaling = 0.;
    double size_dependent_qd = 200.;
    double period_rot = 0.;
    double phase_function = 0.05;
    std::string dumpModelDirectoryPath;
    std::vector<std::vector<double>> grid_test_num(gridsize_x, std::vector<double> (gridsize_y, 0.0));
    std::vector<std::vector<double>> grid_test_fount(gridsize_x, std::vector<double> (gridsize_y, 0.0));
//
    std::cout << "numerical model calc."  << std::endl;
//
// run numerical model
//   
    afrho1 = core::run_numerical_model(grid_test_num, gridsize_x, gridsize_y, cellsize, gridsize_apex,
           beta, size_index, particle_size, v0, particle_density, size_dependent_qd, Q_sca,
            phase_function, amplitude_rot, period_rot, angular_dependency_index, cosine_scaling,
             dumpModelDirectoryPath);


// 

   double num500 = grid_test_num[30][1];
   double num1000 = grid_test_num[50][1];
        std::cout << "dust 500 km = " << num500 << std::endl;
        std::cout << "dust 1000 km = " << num1000 << std::endl;
        std::cout << "afrho1 " << afrho1 << std::endl;
        std::cout << "end of numerical model "  << std::endl;


//

    std::cout << "fountain model calc."  << std::endl;
//
// run fountain model

//
    afrho2 = core::run_fountain(grid_test_fount, gridsize_x, gridsize_y, cellsize, gridsize_apex,
    beta, size_dependent_qd, particle_size, v0, size_index, particle_density, Q_sca, phase_function, dumpModelDirectoryPath);
//
            std::cout << "afrho2 " << afrho2 << std::endl;
//
// dust density for the fountain model at 3 locations: 2000 km (gridsize_x = 50, 10000 (2000) and 20 000 km (4000)
//
   double fount500 = grid_test_fount[30][1];
   double fount1000 = grid_test_fount[50][1];
        std::cout << "dust 500 km = " << fount500 << std::endl;
        std::cout << "dust 1000 km = " << fount1000 << std::endl;

    //
    // check if result and max_vel are equal within a tolerance of 10%
    //
    double densmax = std::max(fount500,num500);
    if ((abs(fount500 - num500)/densmax) <= 0.1){
        acceptance1 = 0;}
    else {
        std::cout << "more than 10% of difference in dust density at 1000 km" << std::endl;
    }
    //
    densmax = std::max(fount1000,num1000);
    if ((abs(fount1000 - num1000)/densmax) <= 0.1){
        acceptance2 = 0;}
    else {
        std::cout << "more than 10% of difference in dust density at 1500 km" << std::endl;
    }   

    //     
    double afrho = std::max(afrho1,afrho2);
    if ((abs(afrho1 - afrho2)/afrho) <= 0.1){
        acceptance4 = 0;}
    else {
        std::cout << "error on models (afrho computation)" << std::endl;
    }
    //     

    if ((acceptance1 == 0) && (acceptance2 == 0) && (acceptance4 == 0)){
        acceptance = 0;}
    else {
	return 1;
	}	
    //
    // 
    //
    return acceptance;

}




// =================================================================================== //
//standard main function. Editing just the exception message.
int main(int argc, char *argv[])
{
    int val = 1;

    try {
        val = model();
    } catch (std::exception &e) {
        std::cout << "test_10 exited with an error of type : " << e.what() << std::endl;
        return 1;
    }
    
    return val;
}

