//
// Created by Philippe Reynier on 05.04.2023.
// Functional test 6 for Commode 
// Develop on the base of D5 (ISA TN-02v4-2022): Software Verification Plan for Coma Model for 
// Comet Interceptor
//
// Functional test 6 for testing Dust Particle Size Distribution linked to requirement REQ-MODEL-14 (from D2:
// User and Software requirements definition document)
//

#include "utils.h"
#include <iostream>

int part_size_distr(){

    // Test on particle size distribution:
    // Check if the sum of all dust production rates per size bin is equal to the input global dust production rate
    // acceptance is equal to 1 if this is the case
//
    int acceptance = 1;
    int i;
 
    // total production rate
    double totalqd;
   //NH the values of all the things below haveto be initialized. It is ok, if you only have 3-4 size bins.
    //if you have qd as input,  you dont need the routine estimate_production_rate,  q_sca or the phase function
    //NH also noticed that the density and veloctiy for the get_size_dependent_qd are obsolete at this point
    //it doesnt matter what values you assign.
    //the important part is that the size_bins need to have values.
 
  //NH either qd or afrho need to have an assigned value
    double power_law_index = -3.5;
   //NH number_of_bins also needs to have an assigned value
    int  number_of_bins = 3;

    std::vector<double> size_bins(number_of_bins);
    std::vector<double> particle_densities(number_of_bins);
    std::vector<double> terminal_velocities(number_of_bins);

   //NH size_dependent_qd should not be constant. you want to give values to the vector.
    std::vector<double> size_dep_qd(number_of_bins);
    //totalqd does not even get passed to get_size_dependent_qd. 
    //NH: my suggestion is  assign a value to qd.
    totalqd = 100.;
    
    //calculate production rate by size bin
    //
    double qdsumbin = 0.0;
    size_bins[0]= 0.01;
    size_bins[1]= 0.001;
    size_bins[2]= 0.0001;

    for (int i = 0; i < number_of_bins; i++){
        particle_densities[i] = 533.;
        terminal_velocities[i] = 50.;
    }
//
    size_dep_qd = core::get_size_dependent_qd(totalqd, power_law_index, size_bins, particle_densities, terminal_velocities);

    for (int i = 0; i < number_of_bins; i++){
        qdsumbin += size_dep_qd[i];
    }

    // check totalqd and qdsumbin
    //checking dust production rate
    std::cout << "global production rate : " << totalqd << std::endl;
    std::cout << "sum of production rate by size bin : " << qdsumbin  << std::endl;


    if ((totalqd - qdsumbin) <= 0.01 ){
        acceptance = 0;}
    else {
        std::cout << "error on particle size distribution" << std::endl;
	return 1;
    }

    return acceptance;

}




// =================================================================================== //
//standard main function. Editing just the exception message.
int main(int argc, char *argv[])
{
    int val = 1;
 
    try {
        val = part_size_distr();
    } catch (std::exception &e) {
        std::cout << "test_6 exited with an error of type : " << e.what() << std::endl;
        return 1;
    }
    
    return val;
}

