//
// Created by Philippe Reynier on 14.06.2023.
// Functional test 8 for Commode 
// Develop on the base of D5 (ISA TN-02v4-2022): Software Verification Plan for Coma Model for 
// Comet Interceptor
//
// Functional test 9 for Grid initialization linked torequirement REQ-SOFT-02 (from D2:
// User and Software requirements definition document)
//
// For this test it is proposed to check if the calculations cover a volume of space up to 100 000 km from the 
// nucleus on the sunward side


#include "utils.h"
#include <math.h>
#include <vector>
#include <iostream>
#include "grid.h"

int grid_check(){

    // test (acceptance) checks if the minimum volume of space is contained in the grid
    // acceptance is equal to 0 if this is the case
    int acceptance = 1;
    int gridsize_x = 10;
    int gridsize_y = 10;
    int gridsize_apex = 5;
    int cellsize = 50000;
    // 
    core::grid_def(gridsize_x, gridsize_y, cellsize, gridsize_apex);
    //
    // check if the grid extent up to 100 000 kmin the sunward direction
    //
    double dist = gridsize_apex*cellsize;
//
    std::cout << "max dist (m) ="<< dist << std::endl;
    if (dist >= pow(10,8)){
        acceptance = 0;}
    else {
        std::cout << "grid does not extent up to 100 000 km in sunward direction" << std::endl;
	return 1;
    }

    //
    // 
    //


    return acceptance;

}




// =================================================================================== //
//standard main function. Editing just the exception message.
int main(int argc, char *argv[])
{
    int val = 1;

    try {
        val = grid_check();
    } catch (std::exception &e) {
        std::cout << "test_9 exited with an error of type : " << e.what() << std::endl;
        return 1;
    }
    
    return val;
}

