//
// Created by nh18u590 on 18.08.2022.
//

#include <iostream>
#include <tuple>
#include <vector>
#include <random>
#include <math.h>

using namespace std;

namespace core {

int get_cellsize(int resolution_index) {
  int cellsize_temp;

  if (resolution_index == 0) {
    cellsize_temp = 20000;
  }
  return cellsize_temp;
}

int get_gridsize(int cellsize, int max_distance) {
  int gridsize_temp;
  gridsize_temp = max_distance / cellsize;
  return gridsize_temp;
}

// 
// Additional routine for grid parameter definition
// Parameters (excepted cellsize) are passed by reference as their new values is needed in the code
// for one of the functional tests.
// Ph Reynier 26/07/23
//
void  grid_def(int &gridsize_x, int &gridsize_y, int cellsize, int &gridsize_apex){


    //input grid parameters (in [m])
    // max_distance must be at least 100 000 km as per the code requirements and ESA's SoW
    //
    const int max_distance = pow(10,8);
    cellsize = 40000;


    //gridsize does not need to be written to file as this information is only a calculation to get the final grid_sizes
    int gridsize = round(double(max_distance)/double(cellsize));

    //needs to be discussed if gridsize_apex should be a user input - now it is based ESA requirement of 100 000 km in the sunward direction. An alternative could be a value of 60 000 km that is a good estimate of how far the coma extends for astro-silicate
    //also describes where the nucleus is located in the grid
    gridsize_apex = round(max_distance/double(cellsize));

    gridsize_x = gridsize+gridsize_apex;
    gridsize_y = gridsize;

}

} // namespace core