//
// Created by nh18u590 on 18.08.2022.
//

#ifndef UNTITLED_GRID_H
#define UNTITLED_GRID_H

#include <cstdint>
#include <math.h>
#include <vector>

/*!
    \brief core-API main namespace
    Collection of ComMoDE core functions
*/
namespace core {

int get_cellsize(int resolution_index);

/*!
    Once the characteristic cell size  and the total distance to cover are
   provided, calculate the number of cells needed in the mesh as
   distance/cellsize. 
   \param[in] cellsize characteristic size of the cell
   \param[in] max_distance total distance to discretize
   \return number of cells
*/
int get_gridsize(int cellsize, int max_distance);


void  grid_def( int &gridsize_x, int &gridsize_y, int cellsize, int &gridsize_apex);


} // namespace core

#endif // UNTITLED_GRID_H
