//
// Created by nh18u590 on 03.06.2022.
// Modified by RA Optimad on 08.03.2023
//

#ifndef UNTITLED_UTILS_FOUNTAIN_H
#define UNTITLED_UTILS_FOUNTAIN_H

#include <cstdint>
#include <math.h>
#include <iostream>
#include <tuple>
#include <math.h>
#include <fstream>
#include <random>
#include "utils.h"

//all of these function made inline to speed up runtime on MSVC native builds
namespace core{

inline double calc_E(double beta, double v0){
    double E = dist_sun*dist_sun*v0*v0/(2.0*beta*G*M_sun);

    return E;
}

inline void calc_eta(double E, double S, double R, double *eta){
    double denom = std::sqrt((2.0*E+S)*(2.0*E+S) - R*R) + 2.0*E+S;
    *eta = R/denom;
}

inline void calc_time_of_flight(double R, double E, double eta, double *t1, double *t2, double v0){

    *t1 = std::sqrt(4.0*E*R*eta)/v0;
    *t2 = std::sqrt(4.0*E*R/eta)/v0;

}

//d_or_f is 1 for direct and -1 reflected particles
inline void calc_jacobian(double R, double eta, double* jac1, double* jac2, double v0){
    *jac1 = R*R*v0*(eta*eta-1.0);
    *jac2 = R*R*v0*((1.0/(eta*eta))-1.0);

}

inline void directional_distribution(double theta1, double theta2, double* fs1, double* fs2){
    *fs1 = 1.0/(4.0*pi);
    *fs2 = 1.0/(4.0*pi);
}

inline void calc_dust_density(double qd,double fs1, double fs2, double jac1, double jac2, double* dust_density){
    *dust_density = qd*fs1*std::abs(1.0/jac1) + qd*fs2*std::abs(1.0/jac2);
}

inline void emission_direction(double R, double S, double time, double beta, double* theta, double v0){
    double A = (0.5*beta*g_const*time*time-S)/(v0*time);
    if ((A >= -1) && (A <= 1)){
    *theta = pi/2.0 - std::asin(A);
}
    else{
    *theta = 0.0;}
}

}
#endif //UNTITLED_UTILS_FOUNTAIN_H