import sys, os
sys.path.append('..')
from backEnd.runFunctions import ComaSimulationWorker

#Summary
#The current test is made to test python binding of core-API methods.
# It runs a full coma simulation employing the backEnd ComaSimulationWorker class (which calls the binded methods
# inside its own runProcessComa).
#The test requires near it a sample project folder (test003_sampleProject) in order to start correctly the simulation.
#If the simulation is successfull the coma-results subfolder of test003_sampleProject will be populated
# with coma simulation results files.

try: 
    runner = ComaSimulationWorker()
    projectFolder = os.path.join(os.getcwd(), "test003_sampleProject")
    runner.setProjectFolder(os.path.join(os.getcwd(), "test003_sampleProject"))
    runner.runProcessComa(printOnScreen=True)
    check= (runner.getStatus() == 0)
except:
    check = False

if not check:
    print("interface_functional_test_003 passed... :{}".format(check))
    exit()

listfiles = os.listdir(os.path.join(projectFolder, "coma-results"))
if len(listfiles) == 0:
    check = False
else:
    check = True 

print("interface_functional_test_003 passed... :{}".format(check))
